//----------------------------------------------------------------------------
// Math.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: Math.pas
//----------------------------------------------------------------------------
#ifndef MathHPP
#define MathHPP
//----------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <System.hpp>
#pragma warn -par
#pragma warn -hid 
#pragma warn -inl

namespace Math
{
//-- type declarations -------------------------------------------------------
enum TPaymentTime { ptEndOfPeriod, ptStartOfPeriod };

class __declspec(delphiclass) EInvalidArgument;
class __declspec(pascalimplementation) EInvalidArgument : public Sysutils::EMathError
{
	typedef Sysutils::EMathError inherited;
	
public:
	/* Exception.Create */ __fastcall EInvalidArgument(const System::AnsiString Msg) : Sysutils::EMathError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EInvalidArgument(const System::AnsiString Msg, const System::TVarRec 
		*Args, const int Args_Size) : Sysutils::EMathError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EInvalidArgument(int Ident) : Sysutils::EMathError(Ident) { }
	/* Exception.CreateResFmt */ __fastcall EInvalidArgument(int Ident, const System::TVarRec *Args, const 
		int Args_Size) : Sysutils::EMathError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EInvalidArgument(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::EMathError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EInvalidArgument(const System::AnsiString Msg, const System::TVarRec 
		*Args, const int Args_Size, int AHelpContext) : Sysutils::EMathError(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EInvalidArgument(int Ident, int AHelpContext) : Sysutils::
		EMathError(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EInvalidArgument(int Ident, const System::TVarRec *Args
		, const int Args_Size, int AHelpContext) : Sysutils::EMathError(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EInvalidArgument(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define MinSingle  2.39955E-307
#define MaxSingle  2.39955E-307
#define MinDouble  2.39955E-307
#define MaxDouble  2.39955E-307
#define MinExtended  2.39955E-307
#define MaxExtended  2.39955E-307
#define MinComp  2.39955E-307
#define MaxComp  2.39955E-307
extern Extended __fastcall DegToRad(Extended Degrees);
extern Extended __fastcall RadToDeg(Extended Radians);
extern Extended __fastcall GradToRad(Extended Grads);
extern Extended __fastcall RadToGrad(Extended Radians);
extern Extended __fastcall CycleToRad(Extended Cycles);
extern Extended __fastcall RadToCycle(Extended Radians);
extern Extended __fastcall LnXP1(Extended X);
extern Extended __fastcall IntPower(Extended Base, int Exponent);
extern Extended __fastcall ArcCos(Extended X);
extern Extended __fastcall ArcSin(Extended X);
extern Extended __fastcall ArcTan2(Extended Y, Extended X);
extern Extended __fastcall Tan(Extended X);
extern Extended __fastcall Cotan(Extended X);
extern Extended __fastcall Hypot(Extended X, Extended Y);
extern void __fastcall SinCos(Extended Theta, Extended &Sin, Extended &Cos);
extern void __fastcall Frexp(Extended X, Extended &Mantissa, int &Exponent);
extern Extended __fastcall Ldexp(Extended X, int P);
extern int __fastcall Ceil(Extended X);
extern int __fastcall Floor(Extended X);
extern Extended __fastcall Log10(Extended X);
extern Extended __fastcall Log2(Extended X);
extern Extended __fastcall LogN(Extended Base, Extended X);
extern Extended __fastcall Poly(Extended X, const double *Coefficients, const int Coefficients_Size)
	;
extern Extended __fastcall Power(Extended Base, Extended Exponent);
extern Extended __fastcall Cosh(Extended X);
extern Extended __fastcall Sinh(Extended X);
extern Extended __fastcall Tanh(Extended X);
extern Extended __fastcall ArcCosh(Extended X);
extern Extended __fastcall ArcSinh(Extended X);
extern Extended __fastcall ArcTanh(Extended X);
extern Extended __fastcall Mean(const double *Data, const int Data_Size);
extern double __fastcall MinValue(const double *Data, const int Data_Size);
extern double __fastcall MaxValue(const double *Data, const int Data_Size);
extern void __fastcall MeanAndStdDev(const double *Data, const int Data_Size, Extended &Mean, Extended 
	&StdDev);
extern void __fastcall MomentSkewKurtosis(const double *Data, const int Data_Size, Extended &M1, Extended 
	&M2, Extended &M3, Extended &M4, Extended &Skew, Extended &Kurtosis);
extern Extended __fastcall Norm(const double *Data, const int Data_Size);
extern Extended __fastcall PopnStdDev(const double *Data, const int Data_Size);
extern Extended __fastcall PopnVariance(const double *Data, const int Data_Size);
extern Extended __fastcall RandG(Extended Mean, Extended StdDev);
extern Extended __fastcall StdDev(const double *Data, const int Data_Size);
extern Extended __fastcall Sum(const double *Data, const int Data_Size);
extern Extended __fastcall SumOfSquares(const double *Data, const int Data_Size);
extern void __fastcall SumsAndSquares(const double *Data, const int Data_Size, Extended &Sum, Extended 
	&SumOfSquares);
extern Extended __fastcall TotalVariance(const double *Data, const int Data_Size);
extern Extended __fastcall Variance(const double *Data, const int Data_Size);
extern Extended __fastcall DoubleDecliningBalance(Extended Cost, Extended Salvage, int Life, int Period
	);
extern Extended __fastcall SLNDepreciation(Extended Cost, Extended Salvage, int Life);
extern Extended __fastcall SYDDepreciation(Extended Cost, Extended Salvage, int Life, int Period);
extern Extended __fastcall InternalRateOfReturn(Extended Guess, const double *CashFlows, const int CashFlows_Size
	);
extern Extended __fastcall NetPresentValue(Extended Rate, const double *CashFlows, const int CashFlows_Size
	, TPaymentTime PaymentTime);
extern Extended __fastcall FutureValue(Extended Rate, int NPeriods, Extended Payment, Extended PresentValue
	, TPaymentTime PaymentTime);
extern Extended __fastcall InterestPayment(Extended Rate, int Period, int NPeriods, Extended PresentValue
	, Extended FutureValue, TPaymentTime PaymentTime);
extern Extended __fastcall InterestRate(int NPeriods, Extended Payment, Extended PresentValue, Extended 
	FutureValue, TPaymentTime PaymentTime);
extern Extended __fastcall NumberOfPeriods(Extended Rate, Extended Payment, Extended PresentValue, Extended 
	FutureValue, TPaymentTime PaymentTime);
extern Extended __fastcall Payment(Extended Rate, int NPeriods, Extended PresentValue, Extended FutureValue
	, TPaymentTime PaymentTime);
extern Extended __fastcall PeriodPayment(Extended Rate, int Period, int NPeriods, Extended PresentValue
	, Extended FutureValue, TPaymentTime PaymentTime);
extern Extended __fastcall PresentValue(Extended Rate, int NPeriods, Extended Payment, Extended FutureValue
	, TPaymentTime PaymentTime);

}	/* namespace Math */

#pragma warn .par
#pragma warn .hid 
#pragma warn .inl

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Math;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Math
